var fs = require('fs');
var ini = require('ini');
var config = ini.parse(fs.readFileSync(__dirname + '/config.ini', 'utf-8'));
var redis = require('redis');

var irc = require('irc');
var colors = require('irc-colors');

var options = {
    userName: config.globals.irc_nick,
    password: config.globals.nickserv_password,
    sasl: true,
    stripColors: true,
    channels: [config.globals.aaa_pull_channel, config.globals.topup_message_channel, config.globals.messages_in_channel]
};
console.log('Connecting to irc with options:');
console.log(options);

var client = new irc.Client(config.globals.irc_server, config.globals.irc_nick, options);

var redisClient = redis.createClient(config.globals.redis_port, config.globals.redis_host);

client.addListener('message', function (from, to, message) {
    console.log('MESSAGE ' + from + ' => ' + to + ': ' + message);
});

client.addListener('registered', function () {
    console.log('Connected');
    //client.say('NickServ', 'identify ' + config.globals.nickserv_password);
});

client.addListener('join', function (channel, nick, message) { 
    console.log('JOIN ' + channel);
    
    if (channel == config.globals.aaa_pull_channel) {
        redisClient.psubscribe('kimochi.*.text');
    } 
    else if (channel == config.globals.topup_message_channel) {
        redisClient.psubscribe('echi.topup_report.*.message');
    }
    else if (channel == config.globals.messages_in_channel) {
        redisClient.psubscribe('epic.*');
    }
});

client.addListener('notice', function (from, to, message) {
    console.log('NOTICE ' + from + ' => ' + to + ': ' + message);
    return;
    
    if (from == 'NickServ' && message.match('You are now identified for')) {
        console.log('Joining ' + config.globals.aaa_pull_channel);
        client.join(config.globals.aaa_pull_channel);
        
        console.log('Joining ' + config.globals.topup_message_channel);
        client.join(config.globals.topup_message_channel);
        
        console.log('Joining ' + config.globals.messages_in_channel);
        client.join(config.globals.messages_in_channel);
    }
});

client.addListener('pm', function (from, message) {
    console.log('PM ' + from + ' => ME: ' + message);
});

redisClient.on("pmessage", function (pattern, channel, message) {
    if (channel.match(/^kimochi/)) {
        var gateway = channel.match(/gw:(.*)\.text/)[1];
        client.say(config.globals.aaa_pull_channel, message + ' (' + gateway + ')');
    }
    else if (channel.match(/^echi/)) {
        var gateway = channel.match(/gw:(.*)\.message$/)[1];
        if (config.globals.echi_gw_blacklist.split(',').indexOf(gateway) >= 0) {
            return;
        }
        client.say(config.globals.topup_message_channel, message + ' (' + gateway + ')');
    }
    else if (channel.match(/^epic\./)) {
        client.say(config.globals.messages_in_channel, message);
    }
});
